require 'sketchup.rb'

    module KSOR
	
	   UI.menu("PlugIns").add_item("Kileremskive"){KSOR::Polley.new()}
	   
       class Polley

            # store bogstaver evt. med _ er en CONST
            MINDIAP = 40.mm
            MINDIAA = 10.mm
            MINKRVD = 20.mm
            MINKRVB = 15.mm
			
			Sketchup.send_action("showRubyPanel:")
           
            def initialize()
				@model = Sketchup.active_model
				@entities = @model.active_entities
				self.draw_pulley()
			end
			
			def draw_pulley()
                # default MINIMUM values
                @diaP = MINDIAP if not @diaP or (@diaP < MINDIAP) 
                @diaA = MINDIAA if not @diaA or (@diaA < MINDIAA) 
                @krvD = MINKRVD if not @krvD or (@krvD < MINKRVD) 
                @krvB = MINKRVB if not @krvB or (@krvB < MINKRVB)
				return nil unless self.dialog()
				self.draw_beltProfile()
                self.set_beltProfileOnWheel()
                self.pull_pulley()
                self.pull_krave()
		    end
			
		    def dialog()
					prompts = ["Skivediameter (mm) :",
                           "Akseldiameter (mm) :",
                           "Kravediameter (mm) :",
                           "Kravebredde   (mm) :"]
                    values = [@diaP, @diaA, @krvD, @krvB]
                    results = inputbox(prompts, values, "Specifikationer")
                    return nil if not results
					diaP, diaA, krvD, krvB = results
					if (diaP < MINDIAP) || (diaA < MINDIAA) || (krvD < MINKRVD) || (krvB<MINKRVB)
                        UI.messagebox("Mindstevrdi er genindsat - de(n) SKAL overholdes !", MB_OK)
						self.draw_pulley()
						return nil
					else
					    @diaP, @diaA, @krvD, @krvB = results
						return true
                    end
            end    
          
          def draw_beltProfile()
             pt1 = [0, 4.22.mm, 0]
             pt2 = [13.8.mm, 0, 0]
             pt3 = [13.8.mm, 12.7.mm, 0]
             pt4 = [0, 8.48.mm, 0]
             # Call methods on the Entities collection to draw stuff.
             @beltProfile = @entities.add_group()
			 @fullProfile = @beltProfile.entities.add_face(pt1, pt2, pt3, pt4)
          end
          
          def set_beltProfileOnWheel()
                    # Her laves en profil, som svarer til en kilerem
                    #
                    # Skive laves
             @periferi = @entities.add_circle([0,0,0], [0,0,1],@diaP.to_f/2, 48)
                
                # transformation af helpLine p @beltProfile til Origo
             tr = Geom::Transformation.translation([-11.55.mm,-0.69.mm,0])
             @beltProfile.transform!(tr)
                # og videre til cirkelperiferien
             tr = Geom::Transformation.translation([@diaP.to_f/2,0,0])
             @beltProfile.transform!(tr)
                
                # rotate beltProfile 90
             tr = Geom::Transformation.rotation([13.8.mm,0,0], [1,0,0], 90.degrees)
             @entities.transform_entities(tr, @beltProfile)
             
                # gruppen exploderes for at lave FollowMe og findes s ikke mere
             @beltProfile.explode   
             @fullProfile.followme(@periferi)
          end
          
          def pull_pulley()
                # Nu skal siderne p skiven laves 2 mm p hver side
                opSidePeriferi = @entities.add_circle([0,0,12.mm], [0,0,1], @diaP.to_f/2 + 2.25.mm, 48)
                opSideFlade = @entities.add_face opSidePeriferi
                opSideFlade.pushpull(2.mm)
                nedSidePeriferi = @entities.add_circle([0,0,-0.7.mm], [0,0,-1], @diaP.to_f/2 + 2.25.mm, 48)
                nedSideFlade = @entities.add_face(nedSidePeriferi)
                nedSideFlade.pushpull(2.mm)
                cleanUp
          end
          
          def cleanUp()
                # En cylinderflade fjernes, s der bnes ind til remprofilen
               
          end
           
          def pull_krave()
                # En krave til nippel skruer laves efter angivne dimensioner
                # og der skal laves hul til akslen med den givne diameter
           
          end
          
        end  #class   
       

    end    # module